<?php
/* 
Plugin Name: WPicasa
Plugin URI: http://beaucollins.com/wpicasa/
Description: Integrates Picasa with your WordPress blog
Author: Beau Collins
Author URI: http://beaucollins.com
Version: 0.2 beta
*/

	/*------------------------------------------------------
			WPicasa TemplateTags
	-------------------------------------------------------*/
	
function wpicasa_thumbnails($args=''){
	echo wpicasa_get_thumbnails();
}

function wpicasa_get_thumbnails($page=0, $number=0, $type='list', $images='on'){
	global $wpicasa;
	$thumbs = $wpicasa->imagearray;
	$currentpage = ($page) ? $page : $wpicasa->albumpage ;
	$quantity = ($number) ? $number : $wpicasa->thumbsperpage;
	
	$start = ($currentpage-1) * $quantity;
	
	for($i=$start;$i<$quantity + $start;$i++){
		if (!$thumbs[$i]) break;
		$img = wpicasa_get_thumbnail($thumbs[$i][1]);
		$link = get_permalink($thumbs[$i][1]);
		$imgtitle = get_the_title($thumbs[$i][1]);
		$label = ($images == 'on') ? $img : $imgtitle;
		$li = "<li><a href=\"$link\" title=\"$imgtitle\">$label</a></li>\n";
		
		$menu .= $li;
	}
	
	return $menu;
}

function wpicasa_get_thumbnail($id=0){
	global $wpicasa;
	$thumbfilename = get_post_meta($id, 'wpicasa_imgfilename',true);
	if ($thumbfilename) $thumbsrc = $wpicasa->albumpath.'thumbnails/'.$thumbfilename;
	$imgsize = @getimagesize($thumbsrc);
	$thumbsrc = "<img src=\"$thumbsrc\" $imgsize[3] alt=\"$thumbfilename\" />";
	return $thumbsrc;
	
}

function wpicasa_thumbnail($id=0){
	echo wpicasa_get_thumbnail($id);
}

function wpicasa_thumbpage_menu($args=''){
	echo wpicasa_get_thumbpage_menu();
}

function wpicasa_get_thumbpage_menu($selectedclass='selected'){
	global $wpicasa;
	$current = $wpicasa->albumpage;
	$total = $wpicasa->albumpagetotal;
	$url = $wpicasa->albumurl;
	$qpre = (strpos($url,'?')) ? '&' : '?' ;
	if($total>1){	
		for($i=1;$i<$total + 1;$i++){
			if($current == $i){
				$menu .= "<li class=\"$selectedclass\">$i</li>";
			}else{
				$link = $url.$qpre."photopage=$i";
				$menu .= "<li><a href=\"$link\">$i</a></li>";
			}
		}
	}
	
	return $menu;
}

function wpicasa_photo($args=''){
	echo wpicasa_get_photo();
}

function wpicasa_get_photo($id=0, $class='wpicasaphoto'){
	global $wpicasa;
	if(!$id){
		$photosrc = $wpicasa->photosrc;
		$title = $wpicasa->phototitle;
	}else{
		$filename = rawurlencode(get_post_meta($id,'wpicasa_imgfilename',true));
		$photosrc = $wpicasa->albumpath.'images/'.$filename;
		$title = get_the_title($id);
	}
	
	$imgsize = @getimagesize($photosrc);
	
	$imgtag = "<img class=\"$class\" src=\"$photosrc\" alt=\"$title\" $imgsize[3] />";
	
	return $imgtag;
	
}

function wpicasa_next_photo_link(){
	echo wpicasa_get_next_photo_link();
}

function wpicasa_get_next_photo_link($text="Next Photo &raquo;", $title='Next Photo', $class="nextphoto"){
	global $wpicasa;
	$index = $wpicasa->photoindex;
	$index ++;
	if($nextid = $wpicasa->imagearray[$index][1]){
		$link = get_permalink($nextid);
		$linktag = "<a class=\"$class\" href=\"$link\">$text</a>";
		
		return $linktag;
	}
}

function wpicasa_previous_photo_link(){
	echo wpicasa_get_previous_photo_link();
}

function wpicasa_get_previous_photo_link($text='&laquo; Previous Photo', $title="Previous Photo", $class="previousphoto"){
	global $wpicasa;
	$index = $wpicasa->photoindex;
	$index --;
	if($previd = $wpicasa->imagearray[$index][1]){
		$link = get_permalink($previd);
		$linktag = "<a class=\"$class\" href=\"$link\">$text</a>";
		return $linktag;
	}
}

function wpicasa_album_link(){
	echo wpicasa_get_album_link();
}

function wpicasa_get_album_link($text=false,$class='albumlink'){
	global $wpicasa;
	if (!$text) $text = $wpicasa->albumname;
	$url = $wpicasa->albumurl;
	$currentpage = $wpicasa->albumpage;
	$qpre = (strpos($url,'?')) ? '&' : '?' ;
	$url = ($currentpage > 1) ? $url.$qpre."photopage=$currentpage" : $url ;
	$link = "<a href=\"$url\" class=\"$class\" >$text</a>";
	
	return $link;
}

function wpicasa_initialize($posts){
	global $wpicasa;
	if(is_single()){
		$postid = $posts[0]->ID;
		if(get_post_meta($postid,'wpicasa_imagearray',true) || get_post_meta($postid,'wpicasa_imgfilename',true)) $wpicasa = new WPicasa($postid);
	}
	return $posts;
}

function wpicasa_photo_count(){

	echo wpicasa_get_photo_count();

}

function wpicasa_get_photo_count(){
	global $wpicasa;
	return $wpicasa->totalthumbs;
}

function wpicasa_autogallery($content){
	global $wpicasa, $post;
	
	if(!empty($post->post_password)){//if there's a password

		if(stripslashes($_COOKIE['wp-postpass_'.COOKIEHASH]) != $post->post_password){
			return $content;
		}
		
	}
	
	if(is_single()){
	
		if($wpicasa->isthumbs){
			//construct the thumnail page
			$menu = wpicasa_get_thumbpage_menu();
			$thumbnails = wpicasa_get_thumbnails();
			if($menu) $menu = "<div class=\"wpicasamenu\"><ul><li class=\"menulabel\">Page:</li>$menu</ul></div>\n";
			if($thumbnails) $thumbnails = "<div class=\"wpicasathumbnails\"><ul>$thumbnails</ul><div style=\"clear: both; height: 10px;\"></div></div>\n";
			$content = $menu.$thumbnails.$menu.$content;
			
		}elseif($wpicasa->isphoto){
			//putout the photo
			$previous = wpicasa_get_previous_photo_link();
			$next = wpicasa_get_next_photo_link();
			$album = wpicasa_get_album_link();
			
			if ($previous || $album || $next) $menu = "<div class=\"wpicasamenu\">$previous | $album | $next</div>";
			
			if($photo = wpicasa_get_photo()) $photo = "<div class=\"wpicasaphoto\">$photo</div>";;
			$content = $menu.$photo.$menu.$content;
		}
	
	}
	
	return $content;
}

function wpicasa_archivethumb($content){
	global $id, $wpicasa, $post;
	
	if(!empty($post->post_password)){//if there's a password
		if(stripslashes($_COOKIE['wp-postpass_'.COOKIEHASH]) != $post->post_password){
			return $content;
		}		
	}
	
	if(!is_single()){
		if(get_post_meta($id, 'wpicasa_imagearray',true)){
		
			$wpicasa = new WPicasa($id);//wpicasa only automaticcaly called on a single post
			$thumbs = wpicasa_get_thumbnails(false,get_settings('wpicasa_archivethumbsperpost'));
			$albumlink= get_permalink();
			$total = wpicasa_get_photo_count();
			$label = ($total > 1 || $total != 0) ? 'photos' : 'photo' ; 
			if($thumbs) $thumbs .= "<li class=\"wpicasaalbumlink\"><a href=\"$albumlink\"/>$total $label &raquo;</a></li>";
			if($thumbs) $content = "<ul class=\"wpicasapreview\">$thumbs</ul>\n$content";
		}
	}
	return $content;
}

add_action('the_posts','wpicasa_initialize');
add_action('the_content','wpicasa_autogallery');//this will be the function that will be turned on/off with the autogallery option
add_action('the_content','wpicasa_archivethumb');//this will be the function that ass posts to the archive/summary posts
/*------------------------------------------------------------------------------------
	WPicasa
------------------------------------------------------------------------------------*/


class WPicasa {

	var $iswpicasa; // boolean determine if this is relevant to the post
	var $albumid;
	var $albumname;//name of the gallery post
	var $albumurl;//the url of the gallery
	var $albumpage;//the current thumb page being viewed or the thumbpage the photo being viewed is on
	var $albumfolder;//the folder for this Picasa Export
	var $albumpath;//the path to the imagefolder
	var $imagearray;//the images in the gallery with their respective id's
	var $totalthumbs; //total number of images
	var $thumbsperpage;
	var $albumpagetotal;//the number of pages that we'll have thumbs/thumbperpage
	var $isthumbs;//true|false if it is a thumbnail page
	var $isphoto;//true|false if it is a individual photo page
	
	var $photofilename;//filename of the image
	var $photosrc;//the source for the photo
	var $photoindex;//index of the image array
	var $photoid;//post id for the photo
	var $phototitle;
	var $thumblargestside;

	var $wpicasafolder;
	
	function WPicasa($postid){
		//first try to get photoid or albumid
		$this->wpicasafolder = rawurlencode(get_settings('wpicasa_folder'));
		if($this->albumid = get_post_meta($postid,'wpicasa_album',true)){
			$this->photoid = $postid;
			$this->isphoto = true;
			$this->isthumbs = false;
			$this->iswpicasa = true;
			$this->get_photoInfo();
			
		}elseif(get_post_meta($postid,'wpicasa_albumfolder',true)){
			$this->albumid = $postid;
			$this->isthumbs = true;
			$this->iswpicasa = true;
			$this->get_albumInfo();
		}
			
	}
	
	function get_albumInfo(){
		$id = $this->albumid;
		//we have the id, now we just want to fill in those details
		$this->imagearray = unserialize(get_post_meta($id,'wpicasa_imagearray',true));
		$this->albumname = get_the_title($id);
		$this->albumurl = get_permalink($id);
		$this->albumpage = (!$_GET['photopage']) ? 1 : $_GET['photopage'];
		$this->albumfolder = rawurlencode(get_post_meta($id,'wpicasa_albumfolder',true));
		$this->albumpath = get_settings('siteurl').'/wp-content/'.$this->wpicasafolder.'/'.$this->albumfolder.'/';
		$this->totalthumbs = count($this->imagearray);
		$this->thumbsperpage = get_settings('wpicasa_thumbsperpost');
		$this->albumpagetotal = ceil($this->totalthumbs/$this->thumbsperpage);
		
		$this->getThumbSize();
		
	}
	
	function get_photoInfo(){
		$this->get_albumInfo();
		$id = $this->photoid;
		$this->photofilename = rawurlencode(get_post_meta($id,'wpicasa_imgfilename',true));
		$this->photosrc = $this->albumpath.'images/'.$this->photofilename;
		$this->phototitle = get_the_title($id);
		for($i=0;$i<$this->totalthumbs;$i++){
			if($this->imagearray[$i][1]==$id){
				$this->photoindex = $i;
				break;
			}
		}
		$this->albumpage = ceil(($this->photoindex + 1)/$this->thumbsperpage);		
	}
	
	function getThumbSize(){	
	

		$thumbsrc = $this->albumpath.'thumbnails/'.$this->imagearray[0][0];
		$thumbsize = getimagesize($thumbsrc);
		$this->thumblargestside = ($thumbsize[0] >= $thumbsize[1]) ? $thumbsize[0] : $thumbsize[1] ;	
	}
	
	/*------------------------------------------------------
	These functions are used for the Autogallery
	--------------------------------------------------------*/
	
	function gallery_css(){
		global $wpicasa;
		$thumbsize = ($wpicasa->thumblargestside + 10) . 'px';
		echo "<style>
		ul.wpicasapreview {
		 float: left;
		 list-style: none !important;
		 padding: 0 !important;
		 margin: 10px !important;
		}
		
		ul.wpicasapreview li{
		 list-style: none !important;
		 padding: 0 !important;
		 margin: 0 !important;
		}
		
		li.wpicasaalbumlink {
		 border-top: 1px solid #ccc;
		}
		
		li.wpicasaalbumlink a {
		 display: block;
		 text-decoration: none;
		 padding: 0 5px;
		 text-align: center;
		 background: #eee;
		}

		.wpicasamenu {
		 clear: both;
		 padding: 3px 0;
		 text-align: center;
		}
		
		.wpicasamenu .selected {
		 font-weight: bold;
		}
		
		.wpicasamenu ul {
		 list-style: none !important;
		 padding: 0 !important;
		 margin: 0 !important;
		}
		
		.wpicasamenu li {
		 display: inline;
		 margin: 3px;
		}
		
		.wpicasathumbnails {
		 text-align: center;
		}

		.wpicasathumbnails ul {
		 padding: 0 !important;
		 margin: 0 !important;
		 list-style: none;
		}
		
		.wpicasathumbnails li {
		 float: left;
		}
		
		.wpicasathumbnails a {
		 display: block;
		 width: $thumbsize;
		 height: $thumbsize;
		 text-align: center;
		}
		
		.wpicasathumbnails img {
		 display: block;
		 padding: 0;
		 border: 0;
		 margin: auto;
		}
		
		.wpicasaphoto img {
		 display: block;
		 margin: auto;
		}

		</style>";		

	}
	
	function photoPermalink($url){//trying to get a permalink for photos problems with passing ID though
		global $wpdb;
		//get the ID with that guid
		$postid = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE guid = '$url' LIMIT 1;");
		//now see if its a wpicasa photo
		if($albumid = get_post_meta($postid,'wpicasa_album',true)){
			$albumurl = get_permalink($albumid);
			$qprefix = (strpos($albumurl,'?')) ? '&' : '?' ;
			$url = $albumurl.$qprefix."wpicasa=$postid";
		}
		//until updated version of WP passes more info on to these plugin functions we'll go off fo the guid
		//however, to make this a way to id on wpicasa posts we'll have to make sure that all photo posts are updated
		//with their new guid whenever rewrite rules are changed, however that creates a problem because you can't
		//use the get_permalink function because it hijacks the whole system
		//return $url;
		return $url;

	}
	
	function grabWPicasa($postcheck){//this is going off the query_string variable that I want to have in photoPermalinks, having problems though
		global $wpdb;		
		if(($photoid = $_GET['wpicasa']) && (count($postcheck)==1)){//if we've got ourselves a wpicasa get_variable
			if(get_post_meta($photoid,'wpicasa_album',true)==$postcheck[0]->ID){
				//lets grab ourselves the post that we want biatch!
				$postcheck = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE ID = $photoid LIMIT 1;");
			}
		}
		return $postcheck;
	}
	
	function customTemplate(){
		global $posts;
		if(is_single() && get_post_meta($posts[0]->ID, 'wpicasa_imagearray', true) && $template = get_settings('wpicasa_gallerytemplate')){
			include(TEMPLATEPATH."/$template");
			exit();
		}
		
		if(is_single() && get_post_meta($posts[0]->ID, 'wpicasa_imgfilename', true) && $template = get_settings('wpicasa_phototemplate')){
			include(TEMPLATEPATH."/$template");
			exit();
		}
	}

}

if(get_settings('wpicasa_autogallery')=='on' && get_settings('wpicasa_css')=='on') add_action('wp_head',array('WPicasa','gallery_css'));
add_filter('the_posts',array('WPicasa','grabWPicasa'),9);
add_filter('post_link',array('WPicasa','photoPermalink'));
add_filter('template_redirect',array('WPicasa','customTemplate'));


/*------------------------------------------------------------------------------------
	WPicasaReader
------------------------------------------------------------------------------------*/
class WPicasaReader{

	var $parser;
	var $depth;
	var $albumname;
	var $albumcaption;
	var $albumcount;
	var $albumsize;
	var $images;
	var $imagecaptions;
	var $currentnode;
	var $path;
	var $wpicasa_album;
	var $exists;
	var $iswpicasadirectory;
	
	function WPicasaReader($album){
		
		$this->path = ABSPATH.'wp-content/'.get_settings('wpicasa_folder').'/'.$album.'/';
		$this->wpicasa_album = $album;
		$this->initiateParser();	
		$this->streamData($this->path.'index.xml');
		$this->releaseParser();
		$this->setAlbumSize();
		$this->checkAlbum();

	}
	
	function initiateParser(){//creates the parser and registers the functions to be used by the parser

		$this->depth = 0;
		$this->parser = xml_parser_create();
		xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING,false);
		xml_set_object($this->parser, $this);
		xml_set_element_handler($this->parser,'openTag','closeTag');
		xml_set_character_data_handler($this->parser,'readData');
	
	}
	
	function releaseParser(){
		xml_parser_free($this->parser);
	}
	
	function openTag($parser, $tag, $attributes){//fired off when a new node is opened
	
		$this->depth ++;
		$this->currentnode = $tag;
	
	}
	
	function closeTag($parser, $tag){//fired off when a node is closed
	
		$this->depth --;
		$this->currentnode = false;
	
	}
	
	function readData($parser, $cdata){//fired off when cdata hits the parser
		
		$cdata = trim($cdata);
		if($cdata){
			if($this->currentnode == 'albumName') $this->albumname = $cdata;
			if($this->currentnode == 'albumItemCount') $this->albumcount = $cdata;
			if($this->currentnode == 'itemName') $this->images[] = $cdata;
			if($this->currentnode == 'itemCaption') $this->imagecaptions[] = $cdata;
			if($this->currentnode == 'albumCaption') $this->albumcaption = $cdata;
		}
		
	}
	
	function streamData($datasource){//open the xml file and stream 'er on in
	
		if(file_exists($datasource)){
			$this->iswpicasadirectory = true;
			if($stream = fopen($datasource, "r")){

				while($data = fread($stream, 4096)){

					if(!xml_parse($this->parser, $data, feof($stream))){
						//echo "error with $datasource<br/>";
						$this->iswpicasadirectory = false;
					}

				}

			}

		}
	
	}
	
	function setAlbumSize(){
	
		if(is_array($this->images)){
			foreach($this->images as $image){
				$size[] = filesize($this->path.'images/'.$image);
			}
		}
			
		if(is_array($size)) $filesize = array_sum($size);
			
		$units = array(' B',' KB',' MB',' GB',' TB');
		if($filesize){
		
			for($i=0;$filesize>1024;$i++){
				$filesize /= 1024;
			}
	
			$filesize = round($filesize, 2).$units[$i];
		
		}else{
		
			$filesize = '0';
		}
		
		$this->albumsize = $filesize;
	}

	function checkAlbum(){
		global $wpdb;
		$test = $wpdb->get_var("SELECT post_ID FROM $wpdb->postmeta WHERE meta_key = 'wpicasa_albumfolder' AND meta_value = '$this->wpicasa_album';");
		if($test){
			$this->exists = true;
		}else{
			$this->exists = false;
		}
	}

	function publishAlbum($status='publish', $password=FALSE, $slug=FALSE){
		global $user_ID, $wpdb;
		if(!$this->exists){
		
			//first we're going to create each photo post

		
			$post['post_title']=$this->albumname;
			$post['post_content']=$this->albumcaption;
			$post['post_status']=$status;
			$post['post_category']=array(1);
			$post['post_author']=$user_ID;
			if($slug) $post['post_name'] = $slug;

			for($i=0;$i<count($this->images);$i++){
				$photoid = $this->publishPhoto($i);
				$photoids[] = $photoid;
				$imagearray[] = array($this->images[$i],$photoid);
			}	

			$albumid = wp_insert_post($post);

			foreach($photoids as $photo){
				add_post_meta($photo,'wpicasa_album',$albumid, true);
			}
			
			
			add_post_meta($albumid,'wpicasa_albumfolder',$this->wpicasa_album,true);
			add_post_meta($albumid,'wpicasa_imagearray',serialize($imagearray),true);
			
			if($password) $wpdb->query("UPDATE $wpdb->posts SET post_password = '$password' WHERE ID = $albumid LIMIT 1;");
			
		}
		
	}
	
	function publishPhoto($i){
		global $user_ID;
		$post['post_title'] = ($this->imagecaptions[$i]) ? $this->imagecaptions[$i] : $this->images[$i];
		$post['post_author'] = $user_ID;
		$post['post_status'] = 'object';
		$post['post_category'] = array(1);
		
		$photoid = wp_insert_post($post);
		add_post_meta($photoid,'wpicasa_imgfilename',$this->images[$i], true);
		add_post_meta($photoid,'wpicasa_folder',$this->wpicasa_album, true);
		return $photoid;
	
	}

	function previewThumbs(){
	
		$imgpath = get_settings('siteurl').'/wp-content/'.rawurlencode(get_settings('wpicasa_folder')).'/'.rawurlencode($this->wpicasa_album).'/thumbnails/';
		$imgs = $this->images;
		$captions = $this->imagecaptions;
		$index = 0;
		if($imgs):foreach($imgs as $img){
		
			$alt= $imgsrc;
			$title = $captions[$index];
			$title = ($title != '') ? " title=\"$title\" " : '';
			$imgsrc = $imgpath.'/'.$img;
			$imgsize = getimagesize($imgsrc);
			$li = "\n\t<li><img $title src=\"$imgsrc\" $imgsizep[3]/></li>";
			
			$list .= $li;
			$index ++;
		
		}endif;
		
		if($list) $list = "<ul class=\"wpicasapreview\">\n$list</ul>";
		
		echo $list;
	}

}
/*------------------------------------------------------------------------------------
	WPicasaAdmin
------------------------------------------------------------------------------------*/
class WPicasaAdmin {

	function adminmenu(){

		add_options_page('WPicasa','WPicasa',9,'wpicasa.php',array('WPicasaAdmin', 'options'));
		add_management_page('WPicasa','WPicasa',5,'wpicasa.php',array('WPicasaAdmin', 'manager'));

	}
	
	function folderList($folder=false){
		
		if($folder===false){
			$folder = get_settings('wpicasa_folder');
		}
	
		$dir = ABSPATH.'wp-content/'.$folder.'/';
		$dh = opendir($dir);
		while(false !== ($filename = readdir($dh))) {
		
			if(is_dir($dir.$filename) && $filename != '.' && $filename != '..'){
				$files[] = $filename;
			}
		}
		
		if(is_array($files)){
			sort($files);
		}
		
		return $files;	
	}
	
	function usedFolders(){
	
		global $wpdb;
		$folders = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key = 'wpicasa_albumfolder';");
		return $folders;
	}
	
	function unusedFolders(){
	
		$list = WPicasaAdmin::folderList();
		$used = WPicasaAdmin::usedFolders();
		if(is_array($list)){//if there are folders
		
			if(is_array($used)){
				foreach($list as $f){
					if(!in_array($f, $used)) $folders[] = $f;
				}
			}else{
				$folders = $list;
			}
			
		}
		
		return $folders;
	}
	
	
	function settings(){
	
		//Default settings for WPicasaPlugin --- (name/required[boolean]/default value/)
		$settings[] = array('wpicasa_folder',true);
		$settings[] = array('wpicasa_thumbsperpost', true, 20);
		$settings[] = array('wpicasa_gallerytemplate',false);
		$settings[] = array('wpicasa_phototemplate',false);
		$settings[] = array('wpicasa_archivethumbsperpost',true,1);
		$settings[] = array('wpicasa_autogallery',true,'on');
		$settings[] = array('wpicasa_css',true,'on');
		return $settings;
	
	}
	
	function updateOptions(){
	
		$settings = WPicasaAdmin::settings();

		foreach($settings as $setting){
			if ($setting[1] && get_settings($setting[0])===false){
				update_option($setting[0],$setting[2]);
			}
		}
	
	}
	
	function checkRequiredOptions(){
	
		$settings = WPicasaAdmin::settings();
		$run = true;
		foreach($settings as $setting){
		
			if(get_settings($setting[0])===false && $setting[1]){
				$run = false;			
			}
		
		}
		
		return $run;
	
	}
	
	function albumQueue(){//create two links now, an autopublish link, and a publish w/options link
	
		$albums = WPicasaAdmin::unusedFolders();
		
		if($albums){
			foreach($albums as $album){
				
				$tempalbum = new WPicasaReader($album);
				if(!$tempalbum->exists && $tempalbum->iswpicasadirectory){
					$autopublish = "?page=$_GET[page]&publish=$album";
					$optionpublish = "?page=$_GET[page]&action=prepublish&album=$album";
					$previewlink = "?page=$_GET[page]&action=preview&album=$album";
					$photolabel = ($tempalbum->albumcount==1) ? 'Photo':'Photos';
					$queue .= "
					<li><div class=\"infobox\"><a href=\"$previewlink\" title=\"Preview thumbnails for $tempalbum->albumname\"><strong>$tempalbum->albumname</strong></a><br/><small>$tempalbum->albumcount $photolabel, $tempalbum->albumsize</small></div>
						<div class=\"publishbox\">Publish &raquo;
						<a href=\"$autopublish\" class=\"albumautopublish\" title=\"Publish $tempalbum->albumname directly to blog\">Auto</a>
						<a href=\"$optionpublish\" class\"albumoptionpublish\" title=\"Configure post-specific options before posting $tempalbum->albumname\">Options</a></div>
					</li>";
	
				}			
			}
		}
	
		if($queue){
			$queue = "<ul>\n$queue\n</ul>";
		}else{
			$queue = "<ul><li><div class=\"infobox\" style=\"background-color: #CCC; color: #333; border: none;\">No Unpublished Albums</div></li></ul>";
		}
		
		return $queue;
	
	}

	function manager(){

	$run = WPicasaAdmin::checkRequiredOptions();
	
	switch($run):

		case true;

		if($album = $_GET['publish']){
			$wpicasa = new WPicasaReader($album);
			$wpicasa->publishAlbum();
		}
		
		if($_POST['wpicasa_optionspublish']){
		
			$album = $_POST['publishwithoptions'];   
			//retrieve the settings and publish post
			//need to update publishAlbum() method
			$wpicasa = new WPicasaReader($album);
			$wpicasa->publishAlbum($_POST['post_status'], $_POST['postpassword'], $_POST['postslug']);
		
		}

	?>
	<div class="wrap">
	<h2>WPicasa - Photo Albums</h2>
	<div class="albumqueue">
	<h3>Unpublished Albums</h3>
	<?php echo WPicasaAdmin::albumQueue();?>
	</div>
	<div class="livealbums">
	<?php $action = $_GET['action']; ?>
	<?php switch($action):
	
		case false;
		
		break;
		
		case 'prepublish';
		
		$tempalbum = new WPicasaReader($_GET['album']);
	?>
	<form method="post" action="?page=<?php echo $_GET['page'] ;?>">
		<input type="hidden" name="publishwithoptions" value="<?php echo $tempalbum->wpicasa_album ;?>" />
	<fieldset class="options">
		<legend>Post with options</legend>
			<h3>Album: <em><?php echo $tempalbum->albumname;?><em></h3>
		<table width="100%" cellspacing="2" cellpadding="5" class="editform"> 
			<tr>
				<th width="33%" valign="top" scope="row">Post Status:</th>
				<td><select name="post_status">
					<option value="publish">Publish</option>
					<option value="draft">Draft</option>
					<option value="private">Private</option>
				</select></td>
			</tr>
			<tr>
				<th width="33%" valign="top" scope="row">Post Password:</th>
				<td><input type="text" name="postpassword" size="25" /></td>
			</tr>
			<tr>
				<th width="33%" valign="top" scope="row">Post Slug:</th>
				<td><input type="text" value="<?php echo sanitize_title($tempalbum->albumname) ;?>" name="postslug" size="25"/></td>
			</tr>
		</table>

		
		<p class="submit"><input type="submit" value="Post" name="wpicasa_optionspublish"/> <input type="submit" value="Cancel" name="wpicasa_cancel" /></p>
	</fieldset>
	</form>
	<?php
		
		break;
		
		case 'preview';
		
		$album = new WPicasaReader($_GET['album']);
		$autolink = "?page=$_GET[page]&publish=$album->wpicasa_album";
		$optionslink = "?page=$_GET[page]&action=prepublish&album=$album->wpicasa_album";
		$backlink = "?page=$_GET[page]";
		
	?>
		<h3>Preview: <em><?php echo $album->albumname;?></em></h3>
		<span class="wpicasaactions">Publish &raquo; <a href="<?php echo $autolink;?>" title="Publish <?php echo $album->albumname;?> directly to blog">Auto</a>
			<a href="<?php echo $optionslink;?>" title="Configure post-specific options before posting <?php echo $album->albumname;?>">Options</a> |
			<a href="<?php echo $backlink;?>" title="Return to album view">Back</a>
		</span>
		<?php $album->previewThumbs();?>
	<?php
		
		break; endswitch; ?>
	</div>
	
	<div class="wpicasafooter"><a href="//beaucollins.com/wpicasa/">WPicasa Help</a></div>
	
	</div>
	<?php
		
		break;

		case false;
	?>
	<div class="wrap">
	<h2>WPicasa - Suspended Status</h2>
	<p>Please go to Options -> WPicasa and configure the required options.</p>
	</div>
	<?php
		
		break;
		
	endswitch;
	
	}
	
	function options(){

		if($_POST['wpicasa_setup_form']){
			$path = ABSPATH.'wp-content/';
			if($folder = $_POST['wpicasa_folder']){
				if(is_dir($path.$folder)){
					if(update_option('wpicasa_folder',$folder)) echo "<div class=\"updated\"><p>Folder Saved - to start using WPicasa, upload your album exports into this folder:<br/><em>$path$folder/</em></p></div>";
				}else{
					echo "<div class=\"updated\">The folder that you chose does not exist, please select a different folder or create a new one.</div>";
				}
			}else{
				if($folder = $_POST['wpicasa_newfolder']){
					if(!is_dir($path.$folder)){
						if(mkdir($path.$folder)){
							update_option('wpicasa_folder',$folder);
							echo "<div class=\"updated\"><p><strong>Directory Created</strong> - to start using WPicasa, upload your album exportsto this folder:<br/><em>$path$folder/</em></p></div>";
						}else{
							echo "<div class=\"updated\"><p><strong>Alert</strong> - WPicasa was not able to create the new directory.</p></div>";
						}
					}else{
						echo "<div class=\"updated\"><p><strong>Error</strong> - The folder you chose to create (<code>$folder</code>) already exists within the <code>wp-content</code> directory.</p></div>";
					}
				}else{
					echo "<div class=\"updated\"><p><strong>Alert</strong> - the folder name you chose is not valid.</div>";
				}
			}
		}

		$run = WPicasaAdmin::checkRequiredOptions();
		
		if($_POST['wpicasa_autogallery_form']){
		
			$optionstoset = array(
					'wpicasa_autogallery',
					'wpicasa_thumbsperpost',
					'wpicasa_archivethumbsperpost',
					'wpicasa_css'
				);
		
			foreach($optionstoset as $option){
				
				$value = $_POST[$option];
				if(($option == 'wpicasa_autogallery' || $option == 'wpicasa_css' ) && !$_POST[$option]) $value = 'off';
				update_option($option, $value);
			
			}
			
			echo '<div class="updated"><p>Autogallery settings saved.</p></div>';
			WPicasaAdmin::updateOptions();//automatically sets default options for required options if removed
		}
		
		if($_POST['wpicasa_template_form']){
			$optionstoset = array(
				'wpicasa_gallerytemplate',
				'wpicasa_phototemplate'
			);
			
			foreach($optionstoset as $option){
				$value = $_POST[$option];
				update_option($option, $value);
			}
			
			echo '<div class="updated"><p>Template settings saved.</p></div>';
			WPicasaAdmin::updateOptions();//automatically sets default options for required options if removed
			
		}	
		
		switch ($run):
		
			case true;

	?>
	<div class="wrap">

	<h2>WPicasa Options</h2>
		<form id="wpicasa_autogallery_form" method="post">
		<input type="hidden" name="wpicasa_autogallery_form" value="true" />
		<fieldset class="options">
			<legend>Photo Display </legend>
				<table width="100%" cellspacing="2" cellpadding="5" class="editform"> 
					<tr>
						<th width="33%" valign="top" scope="row"><label for="autogallery_cb">Autogallery:</label></th> 
						<td>
							<input type="checkbox" name="wpicasa_autogallery" value="on" id="autogallery_cb" <?php if(get_settings('wpicasa_autogallery')=='on') echo 'checked="checked"' ;?> /><br/>
							<small>Automatically display thumbnails and photos in posts.</small>
						</td>
					</tr>					<tr>
						<th width="33%" valign="top" scope="row">Thumbnails Per Page:</th> 
						<td>
							<input type="text" name="wpicasa_thumbsperpost" value="<?php echo get_settings('wpicasa_thumbsperpost');?>" size="2" maxlength="2"/><br/>
							<small>Splits thumbnails into pages of chosen amount.</small>
						</td>
					</tr>
					<tr>
						<th width="33%" valign="top" scope="row">Thumbnails Per Summary/Archive:</th> 
						<td>
							<input type="text" name="wpicasa_archivethumbsperpost" value="<?php echo get_settings('wpicasa_archivethumbsperpost');?>" size="2" maxlength="2"/><br/>
							<small>Thumbnails to show when viewing more than one post or viewing post excerpt.</small>
						</td>
					</tr>
					<tr>
						<th width="33%" valign="top" scope="row">Use Default Styling (CSS):</th> 
						<td>
							<input type="checkbox" name="wpicasa_css" <?php if(get_settings('wpicasa_css')=='on') echo 'checked="checked"' ;?> value="on"/><br/>
							<small>Use default WPicasa <acronym title="Cascading Style Sheets">CSS</acronym></small>
						</td>
					</tr>
					</table>
				<p class="submit"><input type="submit" name="wpicasa_submit" value="Save Photo Display Settings" /></p>
		</fieldset>
		
	</form>
		<form name="wpicasa_presentation" method="post" action="">
		<input type="hidden" name="wpicasa_template_form" value="true" />
		<fieldset class="options">
			<legend>Templates</legend>
				<p style="text-align: center; border-bottom: 1px solid #ccc; padding-bottom: 5px;">When using custom templates with WPicasa template tags, it is recommended to turn off the Autogallery option.</p>
				<table width="100%" cellspacing="2" cellpadding="5" class="editform"> 
					<tr>
						<th width="33%" valign="top" scope="row">Photo Album Template:</th> 
						<td>
							<select name="wpicasa_gallerytemplate">
							<option value=""></option>
							<?php page_template_dropdown(get_settings('wpicasa_gallerytemplate'));?>
							</select><br/>
							<small>Choose a custom template for WPicasa posts.</small>
						</td>
					</tr>
					<tr>
						<th width="33%" valign="top" scope="row">Single Photo Template:</th> 
						<td>
							<select name="wpicasa_phototemplate">
							<option value=""></option>
							<?php page_template_dropdown(get_settings('wpicasa_phototemplate'));?>
							</select><br/>
							<small>Use a custom template to view single photos.</small>
						</td>
					</tr>
				</table>
				<p class="submit"><input type="submit" name="wpicasa_submit" value="Save Template Settings" /></p>
		</fieldset>
	</form>
		
	</div>
	<?php
	
			break;
			
			case false;
	?>
	<div class="wrap">
		<h2>WPicasa - Setup</h2>
		<form method="post" action="">
		<input type="hidden" name="wpicasa_setup_form" value="true" />
		<fieldset class="options">
		<legend>Photo Storage</legend>
				<table width="100%" cellspacing="2" cellpadding="5" class="editform"> 
					<tr>
						<th width="33%" valign="top" scope="row">WPicasa Photo Folder:</th> 
						<td>
							<select name="wpicasa_folder" id="wpicasa_folder_dd">
							<?php if($folders = WPicasaAdmin::folderList('')){
							
								foreach($folders as $folder){
									echo "<option value=\"$folder\">$folder</option>";
								}
							
							};?>	
							<option value="">- Create New Folder</option>
							</select><br/>
							<small>Choose the folder inside your <code>wp-content</code> folder to use as your photo album storage.</small>
						</td>
					</tr>
					<tr id="newalbum_row">
						<th width="33%" valign="top" scope="row" id="wpicasa_newfolder_row">New Folder Name:</th>
						<td>
							<input type="text" name="wpicasa_newfolder" id="wpicasa_newfolder_tb" size="20" /><br/>
							<small>If <em>Create New Folder</em> is selected, type the name of the new folder here.</small>
						</td>
					</tr>
				</table>
				<script type="text/javascript">
				//<!--
				document.getElementById('wpicasa_folder_dd').onchange = function (){
					setState();
				}
				
				function setState(){
					var dd = document.getElementById('wpicasa_folder_dd');
					var tb = document.getElementById('wpicasa_newfolder_tb');
					var therow = document.getElementById('newalbum_row');
					
					if(dd.value==''){
						tb.disabled = false;
						therow.style.visibility = 'visible';
					}else{
						tb.disabled = 'disabled';
						therow.style.visibility = 'hidden';
					}
				}
				
				setState();
				//-->
				</script>
				<p class="submit"><input type="submit" value="Choose Folder" name="wpicasa" /></p>
		</fieldset>
		</fom>
	</div>
	<?php
			
			break;
	
		endswitch;

	}
	

	function deleteAlbum($albumid){//when album is deleted all of the photo posts are deleted as well
		global $wpdb;
		$photos = $wpdb->get_col("SELECT DISTINCT(post_ID) FROM $wpdb->postmeta WHERE meta_key = 'wpicasa_album' AND meta_value='$albumid';");
		if($photos){
			foreach($photos as $photo){
				echo "delete $photo <br/>";
				wp_delete_post($photo);
			}
		}
		return $albumid;
		
	}

	function keepObject($photoid){//when a photo is saved it will be marked as a draft, this will turn it back to an object
		global $wpdb;
		if(get_post_meta($photoid, 'wpicasa_album', true)){//we want the guid to be what the permalink would be
			$guid = get_permalink($photoid);
			$wpdb->query("UPDATE $wpdb->posts SET post_status = 'object' WHERE ID = $photoid LIMIT 1;");
		}
		
		return $photoid;
	}
	
	function guidRefresh($var){
		global $wpdb, $action;
		if($action != 'delete'){
			//first we want every post that is a photo
			$photos = $wpdb->get_col("SELECT post_ID FROM $wpdb->postmeta WHERE meta_key='wpicasa_album';");
			if($photos){
				foreach($photos as $photo){
					$guid = get_permalink($photo);
					if(!strpos($guid, '?')) $wpdb->query("UPDATE $wpdb->posts SET guid = '$guid' WHERE ID = $photo LIMIT 1;");
				}
			}
		}
		return $var;	
	}
	
	function adminCSS(){
	
		echo "
		
		<style type=\"text/css\">
		
		 .albumqueue {
		  float: left;
		  width: 175px;
		  border-right: 1px solid #CCC;
		 }
		 
		 .albumqueue h3 {
		  font-size: .8em;
		  margin: 0 10px 0 0;
		  border-bottom: 1px solid #CCC;
		  padding: 4px;
		 }
		 
		 .albumqueue ul {
		  padding: 10px 5px 10px 0;
		  list-style: none;
		  margin: 0 5px 0 0;
		 }
		
		 .albumqueue li {
		  position: relative;
		  background-color: #CCC;
		  color: #333;
		 }
		 
		 .albumqueue li div.infobox {
		  border-top: 5px solid #888;
		  padding: 5px;
		  background-color: #999;
		  border-bottom: 1px solid #EEE;
		  color: #FFF;
		 }
		 
		 .albumqueue li div.publishbox {
		  font-size: .8em;
		  padding: 0 5px;
		  text-align: right;
		 }
		 
		 .albumqueue a {
		 }
		 
		 .wpicasafooter {
		  clear: both;
		  text-align: right;		  
		 }
		
		 .livealbums {
		  margin-left: 185px;
		 }
		 
		 .livealbums h3 {
		  margin: 0;
		  padding: 4px;
		  border-bottom: 1px solid #CCC;
		  font-size: 1em;
		 }
		 
		 .wpicasapreview {
		  margin: 0;
		  padding: 0;
		  list-style: none;
		  clear: right;
		 }
		 
		 .wpicasapreview li {
		  display: inline;
		 }
		 
		 .wpicasapreview img {
		  vertical-align: middle;
		 }
		 
		 .wpicasaactions {
		  display: block;
		  background: #CCC;
		  float: right;
		  font-size: .8em;
		  padding: 2px 3px;
		 }
		 
		</style>
		
		";
	
	}
}

WPicasaAdmin::updateOptions();
add_action('edit_post',array('WPicasaAdmin','keepObject'));
add_action('delete_post',array('WPicasaAdmin','deleteAlbum'));
add_action('admin_menu',array('WPicasaAdmin', 'adminmenu'));
add_action('generate_rewrite_rules',array('WPicasaAdmin','guidRefresh'));
add_action('admin_head',array('WPicasaAdmin','admincSS'));

?>